<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/sort_seg_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>01/30/84  sort_seg_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The sort_seg_ subroutine provides entry points for sorting segments and
<span id="L4" class="LineNr">  4 </span>character strings.  It is the subroutine interface used by the sort_seg
<span id="L5" class="LineNr">  5 </span>command, and provides all of the facilities of this command at a
<span id="L6" class="LineNr">  6 </span>subroutine level.
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>Entry points in sort_seg_:
<span id="L10" class="LineNr"> 10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>:Entry:  seg:  09/07/83 sort_seg_$seg
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Function:  This entry point sorts an entire segment.  The sorted output
<span id="L17" class="LineNr"> 17 </span>can either replace the original segment or be written into a new
<span id="L18" class="LineNr"> 18 </span>segment.
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>Syntax:
<span id="L22" class="LineNr"> 22 </span>declare sort_seg_$seg entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L23" class="LineNr"> 23 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L24" class="LineNr"> 24 </span>call sort_seg_$seg <span class="textRainbow_lv0_p0">(</span>caller<span class="textRainbow_lv0_o0">,</span> ss_info_ptr<span class="textRainbow_lv0_o0">,</span> in_dir<span class="textRainbow_lv0_o0">,</span> in_ent<span class="textRainbow_lv0_o0">,</span> out_dir<span class="textRainbow_lv0_o0">,</span>
<span id="L25" class="LineNr"> 25 </span>     out_ent<span class="textRainbow_lv0_o0">,</span> out_len<span class="textRainbow_lv0_o0">,</span> undelim_char_index<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Arguments:
<span id="L29" class="LineNr"> 29 </span>caller
<span id="L30" class="LineNr"> 30 </span>   specifies the name of the calling procedure.  Temporary segments
<span id="L31" class="LineNr"> 31 </span>   used for sort work space will be obtained in the caller's name, and
<span id="L32" class="LineNr"> 32 </span>   the user may be asked questions in the caller's name when errors
<span id="L33" class="LineNr"> 33 </span>   occur.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>ss_info_ptr
<span id="L35" class="LineNr"> 35 </span>   points to a structure which defines the type of sorting to be
<span id="L36" class="LineNr"> 36 </span>   performed, the sort field specifications, and so forth.  The caller
<span id="L37" class="LineNr"> 37 </span>   must set all structure elements before calling sort_seg_ entry
<span id="L38" class="LineNr"> 38 </span>   points.  This info structure is declared in sort_seg_info.incl.pl1.
<span id="L39" class="LineNr"> 39 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr"> 40 </span>in_dir
<span id="L41" class="LineNr"> 41 </span>   pathname of the directory containing the segment to be sorted.
<span id="L42" class="LineNr"> 42 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>in_ent
<span id="L46" class="LineNr"> 46 </span>   entryname of the segment to be sorted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L47" class="LineNr"> 47 </span>out_dir
<span id="L48" class="LineNr"> 48 </span>   pathname of the directory in which the sorted results are to be
<span id="L49" class="LineNr"> 49 </span>   placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L50" class="LineNr"> 50 </span>out_ent
<span id="L51" class="LineNr"> 51 </span>   entryname of the segment in which the sorted results are placed.
<span id="L52" class="LineNr"> 52 </span>   The same segment may be identified by in_dir/in_ent and
<span id="L53" class="LineNr"> 53 </span>   out_dir/out_ent, in which case the input segment is replaced by the
<span id="L54" class="LineNr"> 54 </span>   sorted results.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L55" class="LineNr"> 55 </span>out_len
<span id="L56" class="LineNr"> 56 </span>   the length in characters of the sorted results.  This may be useful
<span id="L57" class="LineNr"> 57 </span>   if the caller wants to examine or print the sorted results.
<span id="L58" class="LineNr"> 58 </span>   However, the caller need not truncate or set the bit count for the
<span id="L59" class="LineNr"> 59 </span>   output segment.  sort_seg_ performs these functions.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>undelim_char_index
<span id="L63" class="LineNr"> 63 </span>   if characters are found following the last sort string delimiter in
<span id="L64" class="LineNr"> 64 </span>   the input segment, then this is the character index of the first
<span id="L65" class="LineNr"> 65 </span>   such character in the sorted output results.  Such undelimited
<span id="L66" class="LineNr"> 66 </span>   characters always appear at the end of the sorted output.  It is 0
<span id="L67" class="LineNr"> 67 </span>   if no such undelimited characters are found in the input segment.
<span id="L68" class="LineNr"> 68 </span>   Output)
<span id="L69" class="LineNr"> 69 </span>code
<span id="L70" class="LineNr"> 70 </span>   is a system status code.  If code is nonzero, then sort_seg_ will
<span id="L71" class="LineNr"> 71 </span>   already have printed an error message via sub_err_.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>Access required:
<span id="L75" class="LineNr"> 75 </span>To use the sort_seg_$seg interface, the user must have read access to
<span id="L76" class="LineNr"> 76 </span>the segment being sorted, and rw access to the output segment.  If the
<span id="L77" class="LineNr"> 77 </span>user lacks rw access to the output segment, sort_seg_$seg will ask if
<span id="L78" class="LineNr"> 78 </span>access should be temporarily set to allow sorting.
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>:Entry:  string:  09/07/83 sort_seg_$string
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Function:  This entry point sorts the contents of a character string.
<span id="L85" class="LineNr"> 85 </span>The sorted output can either replace the original string or be written
<span id="L86" class="LineNr"> 86 </span>into another string.
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>Syntax:
<span id="L90" class="LineNr"> 90 </span>declare sort_seg_$string entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L91" class="LineNr"> 91 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L92" class="LineNr"> 92 </span>call sort_seg_$string <span class="textRainbow_lv0_p0">(</span>caller<span class="textRainbow_lv0_o0">,</span> ss_info_ptr<span class="textRainbow_lv0_o0">,</span> in_string<span class="textRainbow_lv0_o0">,</span> out_string<span class="textRainbow_lv0_o0">,</span>
<span id="L93" class="LineNr"> 93 </span>     out_len<span class="textRainbow_lv0_o0">,</span> undelim_char_index<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>Arguments:
<span id="L97" class="LineNr"> 97 </span>caller
<span id="L98" class="LineNr"> 98 </span>   specifies the name of the calling procedure.  Temporary segments
<span id="L99" class="LineNr"> 99 </span>   used for sort work space will be obtained in the caller's name, and
<span id="L100" class="LineNr">100 </span>   the user may be asked questions in the caller's name when errors
<span id="L101" class="LineNr">101 </span>   occur.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L102" class="LineNr">102 </span>ss_info_ptr
<span id="L103" class="LineNr">103 </span>   points to a structure which defines the type of sorting to be
<span id="L104" class="LineNr">104 </span>   performed, the sort field specifications, and so forth.  The caller
<span id="L105" class="LineNr">105 </span>   must set all structure elements before calling sort_seg_ entry
<span id="L106" class="LineNr">106 </span>   points.  This info structure is declared in sort_seg_info.incl.pl1.
<span id="L107" class="LineNr">107 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>
<span id="L110" class="LineNr">110 </span>in_string
<span id="L111" class="LineNr">111 </span>   the string to be sorted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L112" class="LineNr">112 </span>out_string
<span id="L113" class="LineNr">113 </span>   the string in which the sorted results are placed.  The same string
<span id="L114" class="LineNr">114 </span>   may be given for both in_string and out_string, in which case the
<span id="L115" class="LineNr">115 </span>   sorted results overwrite the in_string.  The out_string may also
<span id="L116" class="LineNr">116 </span>   overlap part of the storage for in_string.  When the overlapping is
<span id="L117" class="LineNr">117 </span>   partial or complete, the in_string is copied into a temporary
<span id="L118" class="LineNr">118 </span>   segment prior to being sorted.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L119" class="LineNr">119 </span>out_len
<span id="L120" class="LineNr">120 </span>   the length in characters of the sorted results.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>
<span id="L123" class="LineNr">123 </span>undelim_char_index
<span id="L124" class="LineNr">124 </span>   if characters are found following the last sort string delimiter in
<span id="L125" class="LineNr">125 </span>   the input string, then this is the character index of the first such
<span id="L126" class="LineNr">126 </span>   character in the sorted output results.  Such undelimited characters
<span id="L127" class="LineNr">127 </span>   always appear at the end of the sorted output.  It is 0 if no such
<span id="L128" class="LineNr">128 </span>   undelimited characters are found in the input string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L129" class="LineNr">129 </span>code
<span id="L130" class="LineNr">130 </span>   is a system status code.  If code is nonzero, then sort_seg_ will
<span id="L131" class="LineNr">131 </span>   already have printed an error message via sub_err_.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
